Subject: grep 3.11 -r on 100000+ files fails with "Operation not supported"

From: Santiago Ruano Rincón <[email-masked]>
Date: Fri, 21 Jul 2023 14:10:07 -0300

Dear grep developers,

I am forwarding this gnulib bug that affects grep 3.11. Full bug report
can be found at https://bugs.debian.org/1041588

El 21/07/23 a las 10:39, Vincent Lefevre escribió:
> Control: severity -1 grave
> Control: tags -1 - moreinfo
> Control: retitle -1 grep -r on 100000+ files fails with "Operation not supported"
> 
> On 2023-07-20 23:43:45 -0300, Santiago Ruano Rincón wrote:
> > El 21/07/23 a las 04:06, Vincent Lefevre escribió:
> > > On 2023-07-21 03:30:12 +0200, Vincent Lefevre wrote:
> > > > There is a major regression in grep 3.11-1: I now get an error
> > > > 
> > > > cventin:~/Mail> grep -r xxxyyyzzz oldarc
> > > > grep: oldarc/cur: Operation not supported
> > > 
> > > And no such issue with grep from the upstream git.
> > 
> > How are you compiling it?
> 
> $ ./bootstrap
> $ ./configure --prefix=$HOME/opt/grep
> $ make
> $ make install
> 
> > My intuition is this comes from gnulib.
> 
> Yes, as in my next message, I said that the error disappeared
> with the commit that updated gnulib (and did nothing else).

Indeed. Our mails crossed.

> 
> > But a reproducer is needed to confirm.
> > 
> > Tagging with moreinfo, and downgrading the severity since I cannot
> > reproduce it myself:
> [...]
> > Please, feel free to bump the severity back again if you are able to
> > find out a way to reproduce it.
> 
> One needs at least 100000 files in the directory (99999 is not enough).
> With 100000 empty files:
> 
> $ mkdir test-dir && for i in `seq 100000` ; do : > test-dir/$i ; done
> $ grep -r x test-dir
> grep: test-dir: Operation not supported

Thank you, Vincent. I confirm with 99999 files grep works as expected.

Cheers,

 -- Santiago